
/* extended functions prototypes */

extern long          ext_free           (void);
extern int           alloc_ext          (unsigned int size);
extern int           dealloc_ext        (int handle);

extern int           save_ext           (int handle,
                                         void far * buffer);

extern int           load_ext           (int handle,
                                         void far * buffer);

extern void          ext_setup          (void);
extern int           kbytes_ext         (void);
extern int           cpu_type           (void);

/* expanded functions prototypes */

extern int           save_ems           (int handle,
                                         void far * buffer,
                                         unsigned int size);

extern int           load_ems           (int handle,
                                         void far * buffer,
                                         unsigned int size);

extern int           alloc_ems          (unsigned int size);
extern int           dealloc_ems        (int handle);
extern int           pages_ems          (int mode);
extern int           emm_installed      (void);

/* main functions prototypes */

void                 set_memory_usage   (int usage);
void                 memory_setup       (unsigned int size);
void                 memory_shutdown    (void);
int                  alloc_mem          (unsigned int size);
int                  dealloc_mem        (int block);
int                  save_memory        (int block);
int                  load_memory        (int block);
unsigned long        bytes_available    (void);
unsigned long        bytes_total        (void);

typedef enum
{
 USE_CONV = 1,
 USE_EXT  = 2,
 USE_EMS  = 4,
 NONE     = 0
};

extern void far * dvmam_dta;
